package com.flow.service;


import com.fasterxml.jackson.core.JsonProcessingException;
import com.flow.common.core.model.PageResult;
import com.flow.common.mybatis.service.BaseService;
import com.flow.entity.FlowInstance;
import com.flow.model.FlowInstanceQuery;
import com.flow.model.FormInfo;
import com.flow.model.spreadsheet.SpreadSheet;

import java.util.List;
import java.util.Map;

public interface FlowInstanceService extends BaseService<FlowInstance> {
    /**
     * 待办列表
     * @param flowInstanceQuery
     * @return
     */
    PageResult<FlowInstance> list(FlowInstanceQuery flowInstanceQuery);

    /**
     * 获取流程实例
     * @param instanceId
     * @return
     */
    FlowInstance getInstance(String instanceId);

    /**
     * 获取流程变量
     * @param instanceId
     * @return
     */
    Map<String, Object> getVariables(String instanceId);

    /**
     * 获取流程表单
     * @param instanceId
     * @return
     */
    FormInfo getForm(String instanceId);

    /**
     * 撤回流程
     * @param instanceIds
     */
    void cancel(List<String> instanceIds);

    /**
     * 拒绝流程
     * @param instanceId
     */
    void reject(String instanceId);

    /**
     * 挂起/启用
     * @param instanceId
     */
    void suspend(String instanceId);

    /**
     * 获取流程打印数据
     * @param instanceId
     * @return
     */
    SpreadSheet getPrintData(String instanceId) throws JsonProcessingException;

    Boolean getPrintExist(String instanceId);
}
